﻿using System;
using System.Linq;
using System.Collections.ObjectModel;
using System.IO;
using System.Text;

namespace WindowsFormsApplication1
{
    public class Data
    {
        public Collection<double[]> values = new Collection<double[]>();
        public double[] mean;
        public double[] deviation;

        public void readData(string FileName)
        {
            foreach (var str in File.ReadLines(FileName, Encoding.Default))
            {
                int i;
                string[] strLine = str.Split(',');
                double[] line = new double[strLine.Length];
                for (i = 0; i < strLine.Length; i++)
                    line[i] = Convert.ToDouble(strLine[i]);
                values.Add(line);
            }
        }

        public void calcMean(int features)
        {
            int i, j;
            double[] x;
            double localMean = 0;
            double localDev = 0;

            mean = new double[features];
            deviation = new double[features];
            for (i = 0; i < features; i++)
            {
                localMean = 0;
                for (j = 0; j < values.Count; j++)
                {
                    x = values.ElementAt(j);
                    localMean = localMean + x[i];
                }
                mean[i] = localMean / (values.Count);
            }

            for (i = 0; i < features; i++)
            {
                localDev = 0;
                for (j = 0; j < values.Count; j++)
                {
                    x = values.ElementAt(j);
                    localDev = localDev + (x[i] - mean[i]) * (x[i] - mean[i]);
                }
                deviation[i] = Math.Sqrt(localDev / (values.Count - 1));
            }
        }

        public void normalize(int features)
        {
            int i, j;
            double[] x;
            for (i = 0; i < features; i++)
            {
                for (j = 0; j < values.Count; j++)
                {
                    x = values.ElementAt(j);
                    for (i = 0; i < features; i++)
                    {
                        x[i] = (x[i] - mean[i]) / deviation[i];
                    }
                }
            }
        }
    }
}

